# define RULELIST  1
# define RULE      2
# define LHS       3
# define RHSLIST   4
# define RHS       5
# define NAMELIST  6
# define NAME      7
# define SYMBOL    8

struct Rulelist {
  int var;
  union Node * rule;
  union Node * list;
};

struct Rule {
  int var;
  int id;
  union Node * lhs;
  union Node * rhslist;
};


struct Lhs {
  int var;
  union Node * name;
};

struct Rhslist {
  int var;
  union Node * rhs;
  union Node * list;
};

struct Rhs {
  int var;
  union Node * namelist;
};

struct Namelist {
  int var;
  union Node * name;
  union Node * list;
};

struct Name {
  int var;
  int nvalue;
  int svalue;
};

struct Com {
  int var;
};

union Node {
  struct Rulelist rulelist;
  struct Rule rule;
  struct Lhs lhs;
  struct Rhslist rhslist;
  struct Rhs rhs;
  struct Namelist namelist;
  struct Name name;
  struct Com com;
};











